org.vishia.gral.cfg

## Class GralCfgElement

- java.lang.Object
- - org.vishia.gral.cfg.GralCfgElement

- All Implemented Interfaces:
    java.lang.Cloneable, GralWidgetCfg_ifc
  Direct Known Subclasses:
    GralCfgPanel

      public class GralCfgElement
      extends java.lang.Object
      implements java.lang.Cloneable, GralWidgetCfg_ifc

  ZBNF: Element::= ... ; Class for instance to capture and store one element. Any widget type is an Element. The distinction between different types are given with the `#itsCfgData`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) java.lang.String` | `content` The content is set in textual form too.
    `(package private) GralCfgElement` | `next` The previous element is necessary because non complete coordinates are resolved with previous.
    `private GralCfgPosition` | `position` This obj contains all position data.
    `(package private) GralCfgPosition` | `positionInput` ZBNF: Position coordinates will be filled from [
    `(package private) java.lang.String` | `positionString` The position is set in textual form too.
    `(package private) GralCfgElement` | `previous` The previous element is necessary because non complete coordinates are resolved with previous.
    `static int` | `version` Version and history 2012-04-22 Hartmut chg `setPos(GralMngBuild_ifc)` moved from `GralCfgBuilder.buildWidget(GralCfgElement)` 2012-04-22 Hartmut new `new_ValueBar()` 2011-05-00 Hartmut created, the old ZbnfCfg.. class is obsolte now.
    `(package private) GralCfgData.GuiCfgWidget` | `widgetType`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GralCfgElement()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `GralCfgElement` | `clone()`
    `int` | `get_xPos()`
    `int` | `get_yPos()`
    `java.lang.String` | `getPanel()`
    `GralCfgData.GuiCfgWidget` | `new_Button()`
    `GralCfgData.GuiCfgCurveview` | `new_Curveview()` ZBNF: Curveview::=
    `GralCfgData.GuiCfgImage` | `new_Imagefile()` ZBNF: Imagefile::=
    `GralCfgData.GuiCfgWidget` | `new_InputFile()`
    `GralCfgData.GuiCfgWidget` | `new_InputTextbox()`
    `GralCfgData.GuiCfgWidget` | `new_InputTextline()`
    `GralCfgData.GuiCfgLed` | `new_Led()` ZBNF: Led::=
    `GralCfgData.GuiCfgLine` | `new_Line()` ZBNF: Line::=
    `GralCfgData.GuiCfgWidget` | `new_OutputTextbox()`
    `GralCfgPosition` | `new_position()` ZBNF:
    `GralCfgData.GuiCfgShowField` | `new_ShowField()` ZBNF: ShowField::=
    `GralCfgData.GuiCfgWidget` | `new_SwitchButton()`
    `GralCfgData.GuiCfgTable` | `new_Table()` ZBNF: Table::=
    `GralCfgData.GuiCfgText` | `new_Text()` ZBNF: Text::=
    `GralCfgData.GuiCfgWidget` | `new_ValueBar()` ZBNF: ValueBar::=
    `void` | `set_Button(GralCfgData.GuiCfgWidget data)`
    `void` | `set_Curveview(GralCfgData.GuiCfgCurveview data)` ZBNF: Curveview::=
    `void` | `set_Imagefile(GralCfgData.GuiCfgImage data)` ZBNF: ShowField::=
    `void` | `set_InputFile(GralCfgData.GuiCfgWidget data)`
    `void` | `set_InputTextbox(GralCfgData.GuiCfgWidget data)`
    `void` | `set_InputTextline(GralCfgData.GuiCfgWidget data)`
    `void` | `set_Led(GralCfgData.GuiCfgLed data)` ZBNF: Led::=
    `void` | `set_Line(GralCfgData.GuiCfgLine data)` ZBNF: Line::=
    `void` | `set_OutputTextbox(GralCfgData.GuiCfgWidget data)`
    `void` | `set_position(GralCfgPosition val)` ZBNF:
    `void` | `set_position(java.lang.String val)` ZBNF: [
    `void` | `set_positionString(java.lang.String val)` ZBNF: <*:?
    `void` | `set_ShowField(GralCfgData.GuiCfgShowField data)` ZBNF: ShowField::=
    `void` | `set_SwitchButton(GralCfgData.GuiCfgWidget data)`
    `void` | `set_Table(GralCfgData.GuiCfgTable data)` ZBNF: Table::=
    `void` | `set_Text(GralCfgData.GuiCfgText data)` ZBNF: Text::=
    `void` | `set_ValueBar(GralCfgData.GuiCfgWidget data)` ZBNF: ValueBar::=
    `(package private) void` | `setPanel(java.lang.String panel)`
    `(package private) void` | `setPos(GralMngBuild_ifc guiMng)` Builds the position.
    `private void` | `stop()`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### version

          public static final int version

      Version and history
      - 2012-04-22 Hartmut chg `setPos(GralMngBuild_ifc)` moved from `GralCfgBuilder.buildWidget(GralCfgElement)`
      - 2012-04-22 Hartmut new `new_ValueBar()`
      - 2011-05-00 Hartmut created, the old ZbnfCfg.. class is obsolte now.
      Copyright/Copyleft:
      For this source the LGPL Lesser General Public License, published by the Free Software Foundation is valid. It means:
      1. You can use this source without any restriction for any desired purpose.
      2. You can redistribute copies of this source to everybody.
      3. Every user of this source, also the user of redistribute copies with or without payment, must accept this license for further using.
      4. But the LPGL is not appropriate for a whole software product, if this source is only a part of them. It means, the user must publish this part of source, but doesn't need to publish the whole source of the own product.
      5. You can study and modify (improve) this source for own using or for redistribution, but you have to license the modified sources likewise under this LGPL Lesser General Public License. You mustn't delete this Copyright/Copyleft inscription in this source file.
      If you intent to use this source without publishing its usage, you can get a second license subscribing a special contract with the author.
      See Also:
        Constant Field Values

    - #### previous

          GralCfgElement previous

      The previous element is necessary because non complete coordinates are resolved with previous. The next element is need to build a queue in order of the text.

    - #### next

          GralCfgElement next

      The previous element is necessary because non complete coordinates are resolved with previous. The next element is need to build a queue in order of the text.

    - #### content

          java.lang.String content

      The content is set in textual form too. It is because [...] was written

    - #### positionString

          java.lang.String positionString

      The position is set in textual form too. It is because [...] was written

    - #### positionInput

          final GralCfgPosition positionInput

      ZBNF: Position coordinates will be filled from [.... The instance contains only that position data, which are found in the textual config file. It is important to rewrite only that data, which are contained in the originally one.

    - #### position

          private final GralCfgPosition position

      This obj contains all position data. Missed position data in the `positionInput` are completed by knowledge of the position of the previous elements. The position is filled only in `setPos(GralMngBuild_ifc)` and used nearly only temporary

    - #### widgetType

          GralCfgData.GuiCfgWidget widgetType

  - ### Constructor Detail

    - #### GralCfgElement

          GralCfgElement()

  - ### Method Detail

    - #### clone

          public GralCfgElement clone()

      Overrides:
        `clone` in class `java.lang.Object`

    - #### setPos

          void setPos(GralMngBuild_ifc guiMng)
               throws java.text.ParseException

      Builds the position.
      Parameters:
        `cfge` - deprecated, it is this.
        `guiMng` - to set the position.
      Throws:
        `java.text.ParseException`

    - #### getPanel

          public java.lang.String getPanel()

    - #### setPanel

          void setPanel(java.lang.String panel)

    - #### get_xPos

          public int get_xPos()

    - #### get_yPos

          public int get_yPos()

    - #### new_position

          public GralCfgPosition new_position()

      ZBNF:

    - #### set_positionString

          public void set_positionString(java.lang.String val)

      ZBNF: <*:?position>

    - #### set_position

          public void set_position(java.lang.String val)

      ZBNF: [ ] it is unnecessary

    - #### set_position

          public void set_position(GralCfgPosition val)

      ZBNF:

    - #### new_Text

          public GralCfgData.GuiCfgText new_Text()

      ZBNF: Text::=

    - #### set_Text

          public void set_Text(GralCfgData.GuiCfgText data)

      ZBNF: Text::=

    - #### new_InputTextbox

          public GralCfgData.GuiCfgWidget new_InputTextbox()

    - #### set_InputTextbox

          public void set_InputTextbox(GralCfgData.GuiCfgWidget data)

    - #### new_OutputTextbox

          public GralCfgData.GuiCfgWidget new_OutputTextbox()

    - #### set_OutputTextbox

          public void set_OutputTextbox(GralCfgData.GuiCfgWidget data)

    - #### new_InputTextline

          public GralCfgData.GuiCfgWidget new_InputTextline()

    - #### set_InputTextline

          public void set_InputTextline(GralCfgData.GuiCfgWidget data)

    - #### new_InputFile

          public GralCfgData.GuiCfgWidget new_InputFile()

    - #### set_InputFile

          public void set_InputFile(GralCfgData.GuiCfgWidget data)

    - #### new_Button

          public GralCfgData.GuiCfgWidget new_Button()

    - #### set_Button

          public void set_Button(GralCfgData.GuiCfgWidget data)

    - #### new_SwitchButton

          public GralCfgData.GuiCfgWidget new_SwitchButton()

    - #### set_SwitchButton

          public void set_SwitchButton(GralCfgData.GuiCfgWidget data)

    - #### new_Led

          public GralCfgData.GuiCfgLed new_Led()

      ZBNF: Led::=

    - #### set_Led

          public void set_Led(GralCfgData.GuiCfgLed data)

      ZBNF: Led::=

    - #### new_ValueBar

          public GralCfgData.GuiCfgWidget new_ValueBar()

      ZBNF: ValueBar::=

    - #### set_ValueBar

          public void set_ValueBar(GralCfgData.GuiCfgWidget data)

      ZBNF: ValueBar::=

    - #### new_Line

          public GralCfgData.GuiCfgLine new_Line()

      ZBNF: Line::=

    - #### set_Line

          public void set_Line(GralCfgData.GuiCfgLine data)

      ZBNF: Line::=

    - #### new_Imagefile

          public GralCfgData.GuiCfgImage new_Imagefile()

      ZBNF: Imagefile::=

    - #### set_Imagefile

          public void set_Imagefile(GralCfgData.GuiCfgImage data)

      ZBNF: ShowField::=

    - #### new_ShowField

          public GralCfgData.GuiCfgShowField new_ShowField()

      ZBNF: ShowField::=

    - #### set_ShowField

          public void set_ShowField(GralCfgData.GuiCfgShowField data)

      ZBNF: ShowField::=

    - #### new_Table

          public GralCfgData.GuiCfgTable new_Table()

      ZBNF: Table::=

    - #### set_Table

          public void set_Table(GralCfgData.GuiCfgTable data)

      ZBNF: Table::=

    - #### new_Curveview

          public GralCfgData.GuiCfgCurveview new_Curveview()

      ZBNF: Curveview::=

    - #### set_Curveview

          public void set_Curveview(GralCfgData.GuiCfgCurveview data)

      ZBNF: Curveview::=

    - #### stop

          private void stop()